SystemOrganization addCategory: #'TP BichOS'!

Object subclass: #Alimento
	instanceVariableNames: 'masa posicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Alimento methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/18/2015 13:20'!
extraerComida: limite 
	| masaExtraida |
	masaExtraida := (limite  min: (masa-1) ).
	masa := masa - (masaExtraida + 1).
	^ 0 max: masaExtraida.
 
			! !

!Alimento methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 15:39'!
masa
	^ masa! !

!Alimento methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 15:39'!
masa: anObject
	masa := anObject! !

!Alimento methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 17:21'!
posicion
^ posicion
! !

!Alimento methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 17:21'!
posicion: unPunto
posicion:= unPunto! !

Alimento subclass: #GalletitaOreo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!GalletitaOreo methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 19:58'!
initialize
	masa := 10000! !

Alimento subclass: #MedioAlfajor
	instanceVariableNames: 'chips'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!MedioAlfajor methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 09:31'!
chipsDeChocolate: anObject
	chips := anObject.
	masa := chips * 20! !

!MedioAlfajor methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 20:03'!
initialize
	self chipsDeChocolate: 0! !

Alimento subclass: #MigaDePan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!MigaDePan methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 19:59'!
initialize
	masa := 2000! !

Alimento subclass: #ZapatillaDeLona
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!ZapatillaDeLona methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 19:59'!
extraerComida: limite ! !

Object subclass: #Bicho
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Bicho methodsFor: 'as yet unclassified' stamp: 'JulianBerbel 11/4/2015 23:49'!
esIntrusoEn: unHormiguero
	^ (self estaCercaDe: unHormiguero cercania: 200) & (self perteneceA: unHormiguero) not! !

!Bicho methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 21:20'!
estaCercaDe: unHormiguero cercania: unaCercania
	^ (self posicion distanciaA: (unHormiguero posicion)) < unaCercania! !

!Bicho methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 21:06'!
perteneceA: unHormiguero
	^ unHormiguero hormigas includes: self! !

!Bicho methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 23:03'!
recibirAtaqueGrupalDe: unosAtacantes
	unosAtacantes do: [: unAtacante | unAtacante atacarA: self].
	self removerMuertas: unosAtacantes! !

!Bicho methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 22:33'!
removerMuertas: unasHormigas
	unasHormigas removeAllSuchThat: [: unaHormiga | unaHormiga estaMuerta]! !

Bicho subclass: #Hormiga
	instanceVariableNames: 'estado hormiguero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:57'!
atacarA: unIntruso
	estado atacarA: unIntruso con: self! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/19/2015 11:26'!
descansar
	estado descansar: self.
	! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 09:50'!
distanciaRecorrida
	^estado distanciaRecorrida! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 12:51'!
distanciaRecorridaEnUnaUltimaCantidadDePuntos: unaCantidad 
	^ estado distanciaRecorridaEnUnaUltimaCantidadDePuntos: unaCantidad! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:24'!
distanciaRecorridaPromedio
	^ estado distanciaRecorridaPromedio! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 12:52'!
distanciaRecorridaPromedioEnUnaUltimaCantidadDePuntos: unaCantidad
	^ estado distanciaRecorridaPromedioEnUnaUltimaCantidadDePuntos: unaCantidad! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:52'!
esViolenta
	^ self class = HormigaSoldado! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 23:02'!
estaMuerta
	^ estado class = Muerta! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 16:38'!
estado
	^ estado! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 12:53'!
estado: unEstado
	estado := unEstado! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:27'!
extraerComidaDe: unAlimento
	estado extraerComidaDe: unAlimento con: self ! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:56'!
hormiguero: unHormiguero
	estado hormiguero: unHormiguero! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 12:57'!
irA: unPunto
	estado irA: unPunto con: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:35'!
llevarAlimentoA: unHormiguero
	estado llevarAlimentoA: unHormiguero con: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:55'!
morir
	estado morir: self! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 09:49'!
pesoLlevado
	^ estado pesoLlevado! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 13:32'!
pesoLlevado: unPeso
	estado pesoLlevado: unPeso! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 09:48'!
posicion
	^ estado posicion! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 13:17'!
posicion: unaPosicion
	^ estado posicion: unaPosicion! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 09:48'!
puntosRecorridos
	^ estado puntosRecorridos! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 23:01'!
recibirAtaqueDe: unEnemigo
	estado recibirAtaqueDe: unEnemigo con: self! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 12:58'!
ultimaCantidadDePuntos: unaCantidad 
	^ estado ultimaCantidadDePuntos: unaCantidad! !

Hormiga subclass: #HormigaObrera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:02'!
estaAlLimite
	^  estado estaAlLimite! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:20'!
initialize
	estado := (Normal newConMovilidad: (Movil new) habilidadDeExtraer: (Extractora new))! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:00'!
puntosDeAtaque
	^ 2! !

Hormiga subclass: #HormigaReina
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!HormigaReina methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:05'!
estaAlLimite
	^ false! !

!HormigaReina methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:20'!
initialize
	estado := (Normal newConMovilidad: (NoMovil new) habilidadDeExtraer: (NoExtractora new)).
	estado pesoAEntregarPredeterminado: 0! !

!HormigaReina methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:00'!
puntosDeAtaque
	^ 0! !

Hormiga subclass: #HormigaSoldado
	instanceVariableNames: 'puntosDeVida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 21:31'!
descansar
	puntosDeVida := 20.
	super descansar! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:04'!
estaAlLimite
	^ false! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 21:29'!
initialize
	estado := (Normal newConMovilidad: (Movil new) habilidadDeExtraer: (NoExtractora new)).
	estado pesoAEntregarPredeterminado: 0.
	puntosDeVida := 20! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:18'!
puntosDeAtaque
	^ 5! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 22:31'!
puntosDeVida
	^ puntosDeVida! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:52'!
recibirAtaqueDe: unEnemigo
	self recibirDaño: unEnemigo puntosDeAtaque.
	(puntosDeVida <= 0) ifTrue: [super recibirAtaqueDe: unEnemigo]! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:20'!
recibirAtaqueDe: unEnemigo en: unHormiguero
	self recibirDaño: unEnemigo puntosDeAtaque.
	(puntosDeVida <= 0) ifTrue: [super recibirAtaqueDe: unEnemigo en: unHormiguero]! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:13'!
recibirDaño: unDaño
	puntosDeVida := puntosDeVida - unDaño! !

Hormiga subclass: #HormigaZangano
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!HormigaZangano methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:04'!
estaAlLimite
	^ true! !

!HormigaZangano methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:21'!
initialize
	estado := (Normal newConMovilidad: (NoMovil new) habilidadDeExtraer: (NoExtractora new)).
	estado pesoAEntregarPredeterminado: 1! !

!HormigaZangano methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:00'!
puntosDeAtaque
	^ 0! !

Bicho subclass: #Langosta
	instanceVariableNames: 'movilidad puntosDeVida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Langosta methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 23:09'!
initialize
	puntosDeVida := 50.
	movilidad := Movil new! !

!Langosta methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 21:07'!
posicion
	^ movilidad posicion! !

!Langosta methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 23:08'!
posicion: unaPosicion
	movilidad posicion: unaPosicion! !

!Langosta methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:33'!
puntosDeAtaque
	^ 10! !

!Langosta methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 22:31'!
puntosDeVida
	^ puntosDeVida! !

!Langosta methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:45'!
recibirAtaqueDe: unEnemigo
	self recibirDaño: unEnemigo puntosDeAtaque.
	unEnemigo recibirAtaqueDe: self! !

!Langosta methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:12'!
recibirDaño: unDaño
	puntosDeVida := puntosDeVida - unDaño! !

Object subclass: #Estado
	instanceVariableNames: 'habilidadDeExtraer movilidad hormiguero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

Estado subclass: #Cansada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Cansada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:54'!
cansar: unaHormiga! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:26'!
descansar: unaHormiga
	unaHormiga estado: (Normal newConMovilidad: movilidad habilidadDeExtraer: habilidadDeExtraer).
	movilidad distanciaRecorridaParaCansancio: 0! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:05'!
extraerComidaDe: unAlimento con: unaHormiga! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:38'!
irA: unPunto con: unaHormiga
! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:37'!
llevarAlimentoA: unHormiguero con: unaHormiga
! !

!Estado class methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 12:43'!
newConMovilidad: unaMovilidad habilidadDeExtraer: unaHabilidadDeExtraer
	| unEstado |
	unEstado := self new.
	unEstado movilidad: unaMovilidad.
	unEstado habilidadDeExtraer: unaHabilidadDeExtraer.
	^ unEstado! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:58'!
atacarA: unIntruso con: unaHormiga
	unIntruso recibirAtaqueDe: unaHormiga! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:28'!
distanciaRecorrida
	^  movilidad distanciaRecorrida! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:57'!
distanciaRecorridaEnUnaUltimaCantidadDePuntos: unaCantidad
	^ movilidad distanciaRecorridaEnUnaUltimaCantidadDePuntos: unaCantidad! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:56'!
distanciaRecorridaPromedio
	^  movilidad distanciaRecorridaPromedio! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:56'!
distanciaRecorridaPromedioEnUnaUltimaCantidadDePuntos: unaCantidad
	^ movilidad distanciaRecorridaPromedioEnUnaUltimaCantidadDePuntos: unaCantidad! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:03'!
estaAlLimite
	^ habilidadDeExtraer estaAlLimite! !

!Estado methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 12:33'!
habilidadDeExtraer: anObject
	habilidadDeExtraer := anObject! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 23:04'!
hormiguero: unHormiguero
	hormiguero := unHormiguero! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 23:05'!
morir: unaHormiga
	unaHormiga estado: Muerta new.
	hormiguero removerHormiga: unaHormiga.
	hormiguero := nil! !

!Estado methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 12:33'!
movilidad: anObject
	movilidad := anObject! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:08'!
pesoAEntregarPredeterminado: unPeso
	habilidadDeExtraer pesoAEntregarPredeterminado: unPeso! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:29'!
pesoLlevado
	^ habilidadDeExtraer pesoLlevado! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:33'!
pesoLlevado: unPeso
	habilidadDeExtraer pesoLlevado: unPeso! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:24'!
posicion
	^ movilidad posicion! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:17'!
posicion: unaPosicion
	^ movilidad posicion: unaPosicion! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:35'!
puntosRecorridos
	^ movilidad puntosRecorridos! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 23:02'!
recibirAtaqueDe: unEnemigo con: unaHormiga
	self morir: unaHormiga! !

!Estado methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:25'!
ultimosNPuntos: cantidadN
	^ movilidad ultimosNPuntos: cantidadN! !

Estado subclass: #Exaltada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Exaltada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:26'!
cansar: unaHormiga
	unaHormiga estado: (Normal newConMovilidad: movilidad habilidadDeExtraer: habilidadDeExtraer).
	movilidad distanciaRecorridaParaCansancio: 0! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:32'!
descansar: unaHormiga! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:47'!
extraerComidaDe: unAlimento con: unaHormiga
	self irA: unAlimento posicion con: unaHormiga. 
	habilidadDeExtraer extraerComidaDe: unAlimento limite: 20.! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:53'!
irA: unPunto con: unaHormiga
	((movilidad irA: unPunto) >= 5) ifTrue: [self cansar: unaHormiga].! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:53'!
llevarAlimentoA: unHormiguero con: unaHormiga
	self irA: unHormiguero posicion con: unaHormiga.
	habilidadDeExtraer entregarComidaA: unHormiguero.! !

Estado subclass: #Normal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Normal methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:26'!
cansar: unaHormiga
	unaHormiga estado: (Cansada newConMovilidad: movilidad habilidadDeExtraer: habilidadDeExtraer)! !

!Normal methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:30'!
descansar: unaHormiga
	unaHormiga estado: (Exaltada newConMovilidad: movilidad habilidadDeExtraer: habilidadDeExtraer).
	movilidad distanciaRecorridaParaCansancio: 0.
	
! !

!Normal methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:48'!
extraerComidaDe: unAlimento con: unaHormiga
	self irA: (unAlimento posicion) con: unaHormiga.
	habilidadDeExtraer extraerComidaDe: unAlimento limite: 10.
	! !

!Normal methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:09'!
irA: unPunto con: unaHormiga
	((movilidad irA: unPunto) >= 10) ifTrue: [self cansar: unaHormiga].! !

!Normal methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:48'!
llevarAlimentoA: unHormiguero con: unaHormiga
	self irA: unHormiguero posicion con: unaHormiga.
	habilidadDeExtraer entregarComidaA: unHormiguero.! !

Object subclass: #Extractora
	instanceVariableNames: 'pesoLlevado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Extractora methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:13'!
entregarComidaA: unHormiguero
	unHormiguero aumentarDeposito: pesoLlevado.
	pesoLlevado := 0! !

!Extractora methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:04'!
estaAlLimite
	^ pesoLlevado >= 9! !

!Extractora methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:55'!
extraerComidaDe: unAlimento limite: unLimite
	pesoLlevado := pesoLlevado + (unAlimento extraerComida: unLimite)! !

!Extractora methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:00'!
initialize
	pesoLlevado := 0! !

!Extractora methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:29'!
pesoLlevado
	^ pesoLlevado! !

!Extractora methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:33'!
pesoLlevado: unPeso
	pesoLlevado := unPeso! !

Object subclass: #Hormiguero
	instanceVariableNames: 'hormigas deposito posicion terreno modoDeAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/28/2015 22:42'!
agregarHormiga: unaHormiga
	hormigas add: unaHormiga.
	unaHormiga hormiguero: self! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 21:17'!
alimentoRecolectado
	^ hormigas sum: [: hormiga | hormiga pesoLlevado]! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:37'!
alimentoTotal
	^ deposito + self alimentoRecolectado! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 21:13'!
atacarAIntrusos
	modoDeAtaque atacarA: (self intrusos) en: self! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:51'!
aumentarDeposito: unaCantidad
	self deposito: deposito + unaCantidad ! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/16/2015 16:13'!
cantidadDeHormigas
	^ hormigas size! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
deposito
	^ deposito! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
deposito: anObject
	deposito := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbel 11/4/2015 23:39'!
diezHormigas
	^ (hormigas asArray first: 10) asBag! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
hormigas
	^ hormigas! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
hormigas: anObject
	hormigas := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 21:38'!
hormigasAlLimite
	^ (hormigas select: [: hormiga | hormiga estaAlLimite]) size! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 21:20'!
hormigasCercanas
	^ hormigas select: [: hormiga | hormiga estaCercaDe: self cercania: 500]! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 21:16'!
hormigasViolentas
	^ hormigas select: [: hormiga | hormiga esViolenta]! !

!Hormiguero methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 15:52'!
initialize
self hormigas: Bag new.
deposito:=0.
! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 21:11'!
intrusos
	^ (terreno bichos) select: [: bicho | bicho esIntrusoEn: self]! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/29/2015 22:37'!
modoDeAtaque: unModo
	modoDeAtaque := unModo! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:47'!
posicion
	^ posicion! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:47'!
posicion: anObject
	posicion := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:50'!
reclamarAlimento
	hormigas do: [: hormiga | hormiga llevarAlimentoA: self].! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/17/2015 16:12'!
recorridoTotalHormigas
^self hormigas sum: [ :hormiga | hormiga distanciaRecorrida  ]! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/28/2015 22:23'!
removerHormiga: unaHormiga
	hormigas remove: unaHormiga! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 23:12'!
terreno: unTerreno
	terreno := unTerreno! !

Object subclass: #ModoDeAtaque
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

ModoDeAtaque subclass: #AtaqueConCercanas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!AtaqueConCercanas methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 22:19'!
determinarAtacantes: unHormiguero
	^ unHormiguero hormigasCercanas! !

ModoDeAtaque subclass: #AtaqueConDiez
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!AtaqueConDiez methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 22:19'!
determinarAtacantes: unHormiguero
	^ unHormiguero diezHormigas ! !

ModoDeAtaque subclass: #AtaqueConViolentas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!AtaqueConViolentas methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 22:19'!
determinarAtacantes: unHormiguero
	^ unHormiguero hormigasViolentas! !

!ModoDeAtaque methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 22:43'!
atacarA: unosIntrusos en: unHormiguero
	| atacantes |
	atacantes := self determinarAtacantes: unHormiguero.
	unosIntrusos do: [: intruso | intruso recibirAtaqueGrupalDe: atacantes]! !

Object subclass: #Movil
	instanceVariableNames: 'distanciaRecorrida posicion puntosRecorridos posicionDos distanciaRecorridaParaCansancio distanciaRecorridaEnUnaCantidadDePuntos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:28'!
distanciaRecorrida
	^ distanciaRecorrida! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:31'!
distanciaRecorridaEnUnaUltimaCantidadDePuntos: unaCantidad 

distanciaRecorridaEnUnaCantidadDePuntos := 0.
posicionDos := (self ultimaCantidadDePuntos:unaCantidad )first.

((self ultimaCantidadDePuntos: unaCantidad )allButFirst) do: [ :punto | self irADeUnaCantidadDePuntos: punto ].
^distanciaRecorridaEnUnaCantidadDePuntos.! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:19'!
distanciaRecorridaParaCansancio
	^ distanciaRecorridaParaCansancio! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:19'!
distanciaRecorridaParaCansancio: unaDistancia
	distanciaRecorridaParaCansancio := unaDistancia! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:28'!
distanciaRecorridaPromedio
	^ distanciaRecorrida / (puntosRecorridos size)! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:29'!
distanciaRecorridaPromedioEnUnaUltimaCantidadDePuntos: unaCantidad
	^ (self distanciaRecorridaEnUnaUltimaCantidadDePuntos:unaCantidad ) / unaCantidad! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:00'!
initialize
	distanciaRecorrida := 0.
	distanciaRecorridaParaCansancio := 0.
	puntosRecorridos := OrderedCollection new! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:46'!
irA: unPunto
	distanciaRecorrida := (distanciaRecorrida +(posicion distanciaA: unPunto)).
	distanciaRecorridaParaCansancio := self distanciaRecorridaParaCansancio + (posicion distanciaA: unPunto).
	posicion := unPunto.
	puntosRecorridos add: unPunto.
	^ distanciaRecorridaParaCansancio! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:39'!
irADeUnaCantidadDePuntos: unPunto
	self distanciaRecorridaEnUnaCantidadDePuntos: (distanciaRecorridaEnUnaCantidadDePuntos + (posicionDos distanciaA: unPunto)).
	posicionDos := unPunto.! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:18'!
posicion
	^ posicion! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:18'!
posicion: unaPosicion
	posicion := unaPosicion! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:35'!
puntosRecorridos
	^ puntosRecorridos! !

!Movil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:32'!
ultimaCantidadDePuntos: unaCantidad 
^puntosRecorridos copyFrom:  (puntosRecorridos size) - unaCantidad to: (puntosRecorridos size)! !

Object subclass: #Muerta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

Object subclass: #NoExtractora
	instanceVariableNames: 'pesoAEntregarPredeterminado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!NoExtractora methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 11:14'!
entregarComidaA: unHormiguero
	unHormiguero aumentarDeposito: pesoAEntregarPredeterminado! !

!NoExtractora methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:56'!
extraerComidaDe: unAlimento limite: unLimite! !

!NoExtractora methodsFor: 'accessing' stamp: 'JulianBerbelAlt 10/18/2015 13:11'!
pesoAEntregarPredeterminado: unPeso
	pesoAEntregarPredeterminado := unPeso! !

!NoExtractora methodsFor: 'accessing' stamp: 'JulianBerbel 11/4/2015 12:31'!
pesoLlevado
	^ pesoAEntregarPredeterminado ! !

Object subclass: #NoMovil
	instanceVariableNames: 'posicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!NoMovil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 13:28'!
distanciaRecorrida
	^ 0! !

!NoMovil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:50'!
distanciaRecorridaEnUnaUltimaCantidadDePuntos: unaCantidad
	^ 0! !

!NoMovil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:49'!
distanciaRecorridaPromedio
	^ 0! !

!NoMovil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:49'!
distanciaRecorridaPromedioEnUnaUltimaCantidadDePuntos: unaCantidad
	^ 0! !

!NoMovil methodsFor: 'as yet unclassified' stamp: 'JulianBerbel 11/4/2015 12:33'!
irA: unPunto
	^ 0! !

!NoMovil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:48'!
posicion
	^ posicion! !

!NoMovil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 10:49'!
posicion: unaPosicion
	posicion := unaPosicion! !

!NoMovil methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/18/2015 12:56'!
ultimaCantidadDePuntos: unaCantidad 
	^ OrderedCollection new! !

Object subclass: #Punto
	instanceVariableNames: 'latitud longitud'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Punto methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/16/2015 13:51'!
distanciaA: otroPunto
	^(((latitud-otroPunto latitud)**2)+ ((longitud - otroPunto longitud) **2 ))sqrt.
! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
latitud
	^ latitud! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
latitud: anObject
	latitud := anObject! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
longitud
	^ longitud! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
longitud: anObject
	longitud := anObject! !

Object subclass: #Terreno
	instanceVariableNames: 'bichos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Terreno methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 23:11'!
agregarBicho: unBicho
	bichos add: unBicho! !

!Terreno methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 23:11'!
bichos
	^ bichos! !

!Terreno methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 10/29/2015 23:12'!
initialize
	bichos := Bag new! !
